#ifndef GDS_FPCLASS_HH
#define GDS_FPCLASS_HH

//========================================= floating point type templates
#ifdef __sun
#include <ieeefp.h>
template<typename T>
inline int 
is_finite(T x) {
    switch (fpclass(x)) {
    case FP_SNAN:
    case FP_QNAN:
    case FP_PINF:
    case FP_NINF:
	return 0;
    default:
	return 1;
    }
    return 1;
}

template<typename T>
inline int 
is_normal(T x) {
    switch (fpclass(x)) {
    case FP_PZERO:
    case FP_NZERO:
    case FP_PNORM:
    case FP_NNORM:
	return 1;
    default:
	return 0;
    }
    return 0;
}
#else
template<typename T>
inline int 
is_finite(T x) {
    switch (fpclassify(x)) {
    case FP_NAN:
    case FP_INFINITE:
	return 0;
    default:
	return 1;
    }
    return 0;
}

template<typename T>
inline int 
is_normal(T x) {
    switch (fpclassify(x)) {
    case FP_ZERO:
    case FP_NORMAL:
	return 1;
    default:
	return 0;
    }
    return 0;
}
#endif

#ifndef isfinite
#define isfinite(x) is_finite(x)
#endif

#ifndef isnormal
#define isnormal(x) is_normal(x)
#endif

#endif // !defined(GDS_FPCLASS_HH)
